diff --git a/ports/www/chromium/Makefile.DragonFly b/ports/www/chromium/Makefile.DragonFly
index 70a8b247017..401ca145e09 100644
--- a/ports/www/chromium/Makefile.DragonFly
+++ b/ports/www/chromium/Makefile.DragonFly
@@ -1,13 +1,17 @@
 .if !defined(GN_ONLY)
+
 # XXX - This is a hack to force llvm to use libc++ C++ includes instead of base's gcc
-CXXFLAGS+=	-nostdlib++ -stdlib=libc++ -I${LOCALBASE}/include -I${LOCALBASE}/include/cxxrt
+CXXFLAGS+=	-nostdlib++ -stdlib=libc++ -I${LOCALBASE}/include
 CXXFLAGS+=	-cxx-isystem ${LOCALBASE}/llvm${LLVM_DEFAULT}/libcxx/include/c++/v1
-LDFLAGS=	-L /usr/lib -L${LOCALBASE}/llvm${LLVM_DEFAULT}/libcxx/lib/c++ -L /lib
+LDFLAGS+=	-L /lib -L${LOCALBASE}/llvm${LLVM_DEFAULT}/libcxx/lib/c++ -L /usr/lib -lpthread
 
 # Since FreeBSD has libc++ in base we need to rely on DPorts' libcxx
 LIB_DIRS+=	${PREFIX}/llvm${LLVM_DEFAULT}/libcxx/lib
 LIB_DEPENDS+=  	libc++.so.1:devel/libcxx${LLVM_DEFAULT}
 
+# for C programs
+CFLAGS+=	-I /usr/include
+
 # we don't support libcuse so no audio/virtual_oss
 RUN_DEPENDS:=	${RUN_DEPENDS:Nvirtual_oss*}
 
@@ -15,8 +19,8 @@ RUN_DEPENDS:=	${RUN_DEPENDS:Nvirtual_oss*}
 KERBEROS_LIB_DEPENDS+=	libkrb5.so:security/krb5
 .endif
 
-# XXX - Jumbo builds are faster but some work needs to be done for it to work in dfly.
-#GN_ARGS:= ${GN_ARGS:Nuse_jumbo_build=true}
+# avoid PA for now
+OPTIONS_DEFAULT:=	${OPTIONS_DEFAULT:NPULSEAUDIO}
 
 dfly-patch:
 	# Sandbox stuff
@@ -28,10 +32,6 @@ dfly-patch:
 		${WRKSRC}/sandbox/policy/dragonfly/sandbox_dragonfly.h \
 		${WRKSRC}/sandbox/policy/dragonfly/sandbox_dragonfly.cc \
 
-	# Setup nodejs dependency
-	@${MKDIR} ${WRKSRC}/third_party/node/dragonfly/node-dragonfly/bin
-	${LN} -sf ${LOCALBASE}/bin/node ${WRKSRC}/third_party/node/dragonfly/node-dragonfly/bin/node
-
 	# Chromium uses an unreleased version of FFmpeg, so configure it
 	${CP} -R \
                 ${WRKSRC}/third_party/ffmpeg/chromium/config/Chrome/linux/ \
diff --git a/ports/www/chromium/dragonfly/patch-all b/ports/www/chromium/dragonfly/patch-all
index 6ecc716fa2a..7c61c59709b 100644
--- a/ports/www/chromium/dragonfly/patch-all
+++ b/ports/www/chromium/dragonfly/patch-all
@@ -1,8 +1,8 @@
 diff --git base/BUILD.gn base/BUILD.gn
-index 8afda7a59cf..3578f0e7c31 100644
+index 96c59c077eda..865614aff2fe 100644
 --- base/BUILD.gn
 +++ base/BUILD.gn
-@@ -957,7 +957,7 @@ component("base") {
+@@ -962,7 +962,7 @@ component("base") {
      #"system/sys_info_openbsd.cc",
    ]
  
@@ -11,7 +11,7 @@ index 8afda7a59cf..3578f0e7c31 100644
      sources += [
        "posix/sysctl.cc",
        "posix/sysctl.h",
-@@ -2107,7 +2107,7 @@ component("base") {
+@@ -2140,7 +2140,7 @@ component("base") {
        "process/process_metrics_openbsd.cc",
        "system/sys_info_openbsd.cc",
      ]
@@ -20,11 +20,57 @@ index 8afda7a59cf..3578f0e7c31 100644
      sources += [
        "process/process_handle_freebsd.cc",
        "process/process_iterator_freebsd.cc",
+diff --git base/allocator/partition_allocator/src/partition_alloc/build_config.h base/allocator/partition_allocator/src/partition_alloc/build_config.h
+index 410e7ec222d4..f405cdd92cd8 100644
+--- base/allocator/partition_allocator/src/partition_alloc/build_config.h
++++ base/allocator/partition_allocator/src/partition_alloc/build_config.h
+@@ -93,6 +93,8 @@
+ #define PA_IS_NETBSD
+ #elif defined(__OpenBSD__)
+ #define PA_IS_OPENBSD
++#elif defined(__DragonFly__)
++#define PA_IS_DRAGONFLY
+ #elif defined(__sun)
+ #define PA_IS_SOLARIS
+ #elif defined(__QNXNTO__)
+@@ -110,7 +112,8 @@
+ #define PA_IS_APPLE
+ #endif
+ 
+-#if defined(PA_IS_FREEBSD) || defined(PA_IS_NETBSD) || defined(PA_IS_OPENBSD)
++#if defined(PA_IS_FREEBSD) || defined(PA_IS_NETBSD) || defined(PA_IS_OPENBSD) || \
++    defined(PA_IS_DRAGONFLY)
+ #define PA_IS_BSD
+ #endif
+ 
+@@ -118,7 +121,7 @@
+     defined(PA_IS_FREEBSD) || defined(PA_IS_IOS) || defined(PA_IS_LINUX) ||  \
+     defined(PA_IS_CHROMEOS) || defined(PA_IS_MAC) || defined(PA_IS_NACL) ||  \
+     defined(PA_IS_NETBSD) || defined(PA_IS_OPENBSD) || defined(PA_IS_QNX) || \
+-    defined(PA_IS_SOLARIS) || PA_BUILDFLAG(IS_CHROMEOS)
++    defined(PA_IS_SOLARIS) || PA_BUILDFLAG(IS_CHROMEOS) || defined(PA_IS_DRAGONFLY)
+ #define PA_IS_POSIX
+ #endif
+ 
+@@ -472,6 +475,13 @@
+ #endif
+ #undef PA_IS_OPENBSD
+ 
++#if defined(PA_IS_DRAGONFLY)
++#define PA_BUILDFLAG_INTERNAL_IS_DRAGONFLY() (1)
++#else
++#define PA_BUILDFLAG_INTERNAL_IS_DRAGONFLY() (0)
++#endif
++#undef PA_IS_DRAGONFLY
++
+ #if defined(PA_IS_POSIX)
+ #define PA_BUILDFLAG_INTERNAL_IS_POSIX() (1)
+ #else
 diff --git base/allocator/partition_allocator/src/partition_alloc/spinning_mutex.cc base/allocator/partition_allocator/src/partition_alloc/spinning_mutex.cc
-index 38eda0e9336..32dc555db05 100644
+index 27ff6cc07cb4..884c606afc61 100644
 --- base/allocator/partition_allocator/src/partition_alloc/spinning_mutex.cc
 +++ base/allocator/partition_allocator/src/partition_alloc/spinning_mutex.cc
-@@ -25,6 +25,8 @@
+@@ -24,6 +24,8 @@
  #include <sys/types.h>
  #include <sys/thr.h>
  #include <sys/umtx.h>
@@ -33,7 +79,7 @@ index 38eda0e9336..32dc555db05 100644
  #else
  #include <linux/futex.h>
  #endif
-@@ -123,6 +125,8 @@ void SpinningMutex::FutexWait() {
+@@ -121,6 +123,8 @@ void SpinningMutex::FutexWait() {
  #elif defined(OS_OPENBSD)
    int err = futex(reinterpret_cast<volatile unsigned int *>(&state_), FUTEX_WAIT | FUTEX_PRIVATE_FLAG,
                      kLockedContended, nullptr, nullptr);
@@ -42,7 +88,7 @@ index 38eda0e9336..32dc555db05 100644
  #else
    int err = syscall(SYS_futex, &state_, FUTEX_WAIT | FUTEX_PRIVATE_FLAG,
                      kLockedContended, nullptr, nullptr, 0);
-@@ -144,6 +148,8 @@ void SpinningMutex::FutexWake() {
+@@ -142,6 +146,8 @@ void SpinningMutex::FutexWake() {
  #elif defined(OS_OPENBSD)
    long retval = futex(reinterpret_cast<volatile unsigned int *>(&state_), FUTEX_WAKE | FUTEX_PRIVATE_FLAG,
                          1 /* wake up a single waiter */, nullptr, nullptr);
@@ -51,37 +97,37 @@ index 38eda0e9336..32dc555db05 100644
  #else
    long retval = syscall(SYS_futex, &state_, FUTEX_WAKE | FUTEX_PRIVATE_FLAG,
                          1 /* wake up a single waiter */, nullptr, nullptr, 0);
-diff --git base/allocator/partition_allocator/src/partition_alloc/starscan/stack/stack.cc base/allocator/partition_allocator/src/partition_alloc/starscan/stack/stack.cc
-index f0b1f1b0554..070d356cd28 100644
---- base/allocator/partition_allocator/src/partition_alloc/starscan/stack/stack.cc
-+++ base/allocator/partition_allocator/src/partition_alloc/starscan/stack/stack.cc
+diff --git base/allocator/partition_allocator/src/partition_alloc/stack/stack.cc base/allocator/partition_allocator/src/partition_alloc/stack/stack.cc
+index 7d3b5baebfc5..66f1af0dbf88 100644
+--- base/allocator/partition_allocator/src/partition_alloc/stack/stack.cc
++++ base/allocator/partition_allocator/src/partition_alloc/stack/stack.cc
 @@ -63,7 +63,7 @@ void* GetStackTop() {
    return reinterpret_cast<uint8_t*>(ss.ss_sp);
  }
  
--#elif defined(OS_FREEBSD)
-+#elif defined(OS_FREEBSD) || defined(OS_DRAGONFLY)
+-#elif PA_BUILDFLAG(IS_FREEBSD)
++#elif PA_BUILDFLAG(IS_FREEBSD) || PA_BUILDFLAG(IS_DRAGONFLY)
  
  void* GetStackTop() {
     pthread_attr_t attr;
 diff --git base/base_paths_posix.cc base/base_paths_posix.cc
-index b943bd8331f..c4595dca77d 100644
+index 54cb09377597..93907e334f07 100644
 --- base/base_paths_posix.cc
 +++ base/base_paths_posix.cc
-@@ -52,7 +52,7 @@ bool PathProviderPosix(int key, FilePath* result) {
+@@ -53,7 +53,7 @@ bool PathProviderPosix(int key, FilePath* result) {
        }
        *result = bin_dir;
        return true;
 -#elif BUILDFLAG(IS_FREEBSD)
 +#elif BUILDFLAG(IS_FREEBSD) || BUILDFLAG(IS_DRAGONFLY)
-       absl::optional<std::string> bin_dir = StringSysctl({ CTL_KERN, KERN_PROC, KERN_PROC_PATHNAME, -1 });
+       std::optional<std::string> bin_dir = StringSysctl({ CTL_KERN, KERN_PROC, KERN_PROC_PATHNAME, -1 });
        if (!bin_dir.has_value() || bin_dir.value().length() <= 1) {
-         NOTREACHED() << "Unable to resolve path.";
+         NOTREACHED_IN_MIGRATION() << "Unable to resolve path.";
 diff --git base/debug/debugger_posix.cc base/debug/debugger_posix.cc
-index 95630588208..62d99dc3b45 100644
+index b42b9e52b9a6..7ea774aab290 100644
 --- base/debug/debugger_posix.cc
 +++ base/debug/debugger_posix.cc
-@@ -39,7 +39,7 @@
+@@ -45,7 +45,7 @@
  #include <sys/proc.h>
  #endif
  
@@ -90,7 +136,7 @@ index 95630588208..62d99dc3b45 100644
  #include <sys/user.h>
  #endif
  
-@@ -137,6 +137,8 @@ bool BeingDebugged() {
+@@ -142,6 +142,8 @@ bool BeingDebugged() {
    being_debugged = (info.ki_flag & P_TRACED) != 0;
  #elif BUILDFLAG(IS_OPENBSD)
    being_debugged = (info->p_psflags & PS_TRACED) != 0;
@@ -100,10 +146,10 @@ index 95630588208..62d99dc3b45 100644
    being_debugged = (info.kp_proc.p_flag & P_TRACED) != 0;
  #endif
 diff --git base/debug/proc_maps_linux.cc base/debug/proc_maps_linux.cc
-index 147dc2a5b4e..d179349f879 100644
+index 607e2d36c889..1154890760de 100644
 --- base/debug/proc_maps_linux.cc
 +++ base/debug/proc_maps_linux.cc
-@@ -119,9 +119,16 @@ bool ParseProcMaps(const std::string& input,
+@@ -124,9 +124,16 @@ bool ParseProcMaps(const std::string& input,
      // The final %n term captures the offset in the input string, which is used
      // to determine the path name. It *does not* increment the return value.
      // Refer to man 3 sscanf for details.
@@ -121,10 +167,10 @@ index 147dc2a5b4e..d179349f879 100644
        return false;
      }
 diff --git base/debug/stack_trace_posix.cc base/debug/stack_trace_posix.cc
-index d7e0cb370ad..40342f30e28 100644
+index c05861aec8be..b6e116f98b83 100644
 --- base/debug/stack_trace_posix.cc
 +++ base/debug/stack_trace_posix.cc
-@@ -813,7 +813,11 @@ class SandboxSymbolizeHelper {
+@@ -818,7 +818,11 @@ class SandboxSymbolizeHelper {
      {
        ScopedPrSetDumpable s;
        mem_fd = base::ScopedFD(
@@ -136,7 +182,7 @@ index d7e0cb370ad..40342f30e28 100644
        if (!mem_fd.is_valid()) {
          return;
        }
-@@ -870,6 +874,7 @@ class SandboxSymbolizeHelper {
+@@ -875,6 +879,7 @@ class SandboxSymbolizeHelper {
    // Parses /proc/self/maps in order to compile a list of all object file names
    // for the modules that are loaded in the current process.
    // Returns true on success.
@@ -145,10 +191,10 @@ index d7e0cb370ad..40342f30e28 100644
  #if BUILDFLAG(IS_BSD)
      return false;
 diff --git base/files/dir_reader_linux.h base/files/dir_reader_linux.h
-index 8ebf97840b4..8edaf95e875 100644
+index 5a7ec366fd02..24a349da149d 100644
 --- base/files/dir_reader_linux.h
 +++ base/files/dir_reader_linux.h
-@@ -62,7 +62,7 @@ class DirReaderLinux {
+@@ -67,7 +67,7 @@ class DirReaderLinux {
    bool Next() {
      if (size_) {
        linux_dirent* dirent = reinterpret_cast<linux_dirent*>(&buf_[offset_]);
@@ -158,7 +204,7 @@ index 8ebf97840b4..8edaf95e875 100644
  
      if (offset_ != size_)
 diff --git base/files/file_path_watcher_kqueue.h base/files/file_path_watcher_kqueue.h
-index 1bae61cb3b9..ef9407c234b 100644
+index 1bae61cb3b97..ef9407c234bc 100644
 --- base/files/file_path_watcher_kqueue.h
 +++ base/files/file_path_watcher_kqueue.h
 @@ -6,8 +6,14 @@
@@ -177,10 +223,10 @@ index 1bae61cb3b9..ef9407c234b 100644
  #include <vector>
  
 diff --git base/logging_unittest.cc base/logging_unittest.cc
-index 529e3243da3..5636d2db771 100644
+index 667561d2cffc..9340f43c86f6 100644
 --- base/logging_unittest.cc
 +++ base/logging_unittest.cc
-@@ -32,7 +32,8 @@
+@@ -41,7 +41,8 @@
  #include "base/posix/eintr_wrapper.h"
  #endif  // BUILDFLAG(IS_POSIX)
  
@@ -190,7 +236,7 @@ index 529e3243da3..5636d2db771 100644
  #include <ucontext.h>
  #endif
  
-@@ -575,7 +576,7 @@ void CheckCrashTestSighandler(int, siginfo_t* info, void* context_ptr) {
+@@ -579,7 +580,7 @@ void CheckCrashTestSighandler(int, siginfo_t* info, void* context_ptr) {
    // need the arch-specific boilerplate below, which is inspired by breakpad.
    // At the same time, on OSX, ucontext.h is deprecated but si_addr works fine.
    uintptr_t crash_addr = 0;
@@ -201,7 +247,7 @@ index 529e3243da3..5636d2db771 100644
    ucontext_t* context = reinterpret_cast<ucontext_t*>(context_ptr);
 diff --git base/message_loop/message_loop_task_runner.cc base/message_loop/message_loop_task_runner.cc
 new file mode 100644
-index 00000000000..72989b078cb
+index 000000000000..72989b078cb6
 --- /dev/null
 +++ base/message_loop/message_loop_task_runner.cc
 @@ -0,0 +1,185 @@
@@ -391,7 +437,7 @@ index 00000000000..72989b078cb
 +
 +}  // namespace base
 diff --git base/message_loop/message_pump_glib.cc base/message_loop/message_pump_glib.cc
-index cf4871601cf..f6ec34e007d 100644
+index e07537d654fa..60f6d8a617c4 100644
 --- base/message_loop/message_pump_glib.cc
 +++ base/message_loop/message_pump_glib.cc
 @@ -7,6 +7,7 @@
@@ -402,7 +448,7 @@ index cf4871601cf..f6ec34e007d 100644
  
  #if BUILDFLAG(IS_BSD)
  #include <pthread.h>
-@@ -661,6 +662,14 @@ void MessagePumpGlib::HandleDispatch() {
+@@ -664,6 +665,14 @@ void MessagePumpGlib::HandleDispatch() {
    }
  }
  
@@ -418,7 +464,7 @@ index cf4871601cf..f6ec34e007d 100644
    RunState state(delegate);
  
 diff --git base/posix/can_lower_nice_to.cc base/posix/can_lower_nice_to.cc
-index ada0b21994e..01bdff92582 100644
+index ada0b21994e5..01bdff925827 100644
 --- base/posix/can_lower_nice_to.cc
 +++ base/posix/can_lower_nice_to.cc
 @@ -11,7 +11,7 @@
@@ -431,10 +477,10 @@ index ada0b21994e..01bdff92582 100644
  #endif
  
 diff --git base/process/launch_posix.cc base/process/launch_posix.cc
-index 399502bbe66..0ada1ece6d5 100644
+index 237c642a6f9f..24d0bbbc83ec 100644
 --- base/process/launch_posix.cc
 +++ base/process/launch_posix.cc
-@@ -55,7 +55,7 @@
+@@ -57,7 +57,7 @@
  #include <sys/ioctl.h>
  #endif
  
@@ -443,7 +489,7 @@ index 399502bbe66..0ada1ece6d5 100644
  #include <sys/event.h>
  #include <sys/ucontext.h>
  #endif
-@@ -211,6 +211,8 @@ static const char kFDDir[] = "/dev/fd";
+@@ -213,6 +213,8 @@ static const char kFDDir[] = "/dev/fd";
  static const char kFDDir[] = "/dev/fd";
  #elif BUILDFLAG(IS_OPENBSD)
  static const char kFDDir[] = "/dev/fd";
@@ -453,10 +499,10 @@ index 399502bbe66..0ada1ece6d5 100644
  static const char kFDDir[] = "/proc/self/fd";
  #endif
 diff --git base/process/process_handle_freebsd.cc base/process/process_handle_freebsd.cc
-index 9a03e146c54..fb4d2f17b13 100644
+index f5b1c5b006c4..2bc34444d907 100644
 --- base/process/process_handle_freebsd.cc
 +++ base/process/process_handle_freebsd.cc
-@@ -29,7 +29,11 @@ ProcessId GetParentProcessId(ProcessHandle process) {
+@@ -30,7 +30,11 @@ ProcessId GetParentProcessId(ProcessHandle process) {
    if (length < sizeof(struct kinfo_proc))
      return -1;
  
@@ -469,7 +515,7 @@ index 9a03e146c54..fb4d2f17b13 100644
  
  FilePath GetProcessExecutablePath(ProcessHandle process) {
 diff --git base/process/process_iterator.h base/process/process_iterator.h
-index a819ae1327f..af123729ab4 100644
+index a819ae1327fa..af123729ab42 100644
 --- base/process/process_iterator.h
 +++ base/process/process_iterator.h
 @@ -26,7 +26,7 @@
@@ -482,7 +528,7 @@ index a819ae1327f..af123729ab4 100644
  #elif BUILDFLAG(IS_POSIX) || BUILDFLAG(IS_FUCHSIA)
  #include <dirent.h>
 diff --git base/process/process_iterator_freebsd.cc base/process/process_iterator_freebsd.cc
-index 50792e1ce39..913d9fd27d2 100644
+index 50792e1ce399..913d9fd27d2a 100644
 --- base/process/process_iterator_freebsd.cc
 +++ base/process/process_iterator_freebsd.cc
 @@ -23,6 +23,7 @@ ProcessIterator::ProcessIterator(const ProcessFilter* filter)
@@ -538,11 +584,11 @@ index 50792e1ce39..913d9fd27d2 100644
      size_t last_slash = data.rfind('/', exec_name_end);
      if (last_slash == std::string::npos) {
 diff --git base/process/process_metrics_freebsd.cc base/process/process_metrics_freebsd.cc
-index 946063d3cc9..b1fe0e9b156 100644
+index 49879f5d4c9b..a80cdfcb8c9a 100644
 --- base/process/process_metrics_freebsd.cc
 +++ base/process/process_metrics_freebsd.cc
-@@ -19,6 +19,8 @@
- #include "base/process/process_metrics_iocounters.h"
+@@ -18,6 +18,8 @@
+ #include "base/memory/ptr_util.h"
  #include "base/values.h"
  
 +static int fscale_;
@@ -550,39 +596,16 @@ index 946063d3cc9..b1fe0e9b156 100644
  namespace base {
  namespace {
  int GetPageShift() {
-@@ -35,7 +37,19 @@ int GetPageShift() {
- }
- 
- ProcessMetrics::ProcessMetrics(ProcessHandle process)
--    : process_(process) {}
-+    : process_(process) {
-+#if defined(OS_DRAGONFLY)
-+  size_t len = sizeof(int);
-+  int val;
-+
-+  if (sysctlbyname("kern.fscale", &val, &len, NULL, 0) == 0) {
-+    fscale_ = val;
-+    return;
-+  }
-+#else
-+  fscale_ = FSCALE;
-+#endif
-+}
- 
- // static
- std::unique_ptr<ProcessMetrics> ProcessMetrics::CreateProcessMetrics(
-@@ -53,7 +67,9 @@ TimeDelta ProcessMetrics::GetCumulativeCPUUsage() {
+@@ -52,30 +54,39 @@ ProcessMetrics::GetCumulativeCPUUsage() {
    if (sysctl(mib, std::size(mib), &info, &length, NULL, 0) < 0)
-     return TimeDelta();
+     return base::ok(TimeDelta());
  
--  return Microseconds(info.ki_runtime);
++#ifdef __FreeBSD__
+   return base::ok(Microseconds(info.ki_runtime));
++#else
 +  return Microseconds(TimeValToMicroseconds(info.kp_ru.ru_utime) +
 +		      TimeValToMicroseconds(info.kp_ru.ru_stime));
-+
- }
- 
- bool ProcessMetrics::GetIOCounters(IoCounters* io_counters) const {
-@@ -61,26 +77,30 @@ bool ProcessMetrics::GetIOCounters(IoCounters* io_counters) const {
++#endif
  }
  
  size_t GetSystemCommitCharge() {
@@ -618,7 +641,7 @@ index 946063d3cc9..b1fe0e9b156 100644
  }
  
  int64_t GetNumberOfThreads(ProcessHandle process) {
-@@ -138,15 +158,20 @@ bool GetSystemMemoryInfo(SystemMemoryInfoKB *meminfo) {
+@@ -133,15 +144,20 @@ bool GetSystemMemoryInfo(SystemMemoryInfoKB *meminfo) {
  }
  
  int ProcessMetrics::GetOpenFdCount() const {
@@ -639,7 +662,7 @@ index 946063d3cc9..b1fe0e9b156 100644
  }
  
  int ProcessMetrics::GetOpenFdSoftLimit() const {
-@@ -180,7 +205,11 @@ size_t ProcessMetrics::GetResidentSetSize() const {
+@@ -175,7 +191,11 @@ size_t ProcessMetrics::GetResidentSetSize() const {
    size_t rss;
  
    if (nproc > 0) {
@@ -651,7 +674,7 @@ index 946063d3cc9..b1fe0e9b156 100644
    } else {
      rss = 0;
    }
-@@ -206,9 +235,15 @@ uint64_t ProcessMetrics::GetVmSwapBytes() const {
+@@ -201,9 +221,15 @@ uint64_t ProcessMetrics::GetVmSwapBytes() const {
    size_t swrss;
  
    if (nproc > 0) {
@@ -668,7 +691,7 @@ index 946063d3cc9..b1fe0e9b156 100644
      swrss = 0;
    }
 diff --git base/process/process_metrics_posix.cc base/process/process_metrics_posix.cc
-index bdef95e4cc5..bc6d574db81 100644
+index bdef95e4cc5e..bc6d574db81a 100644
 --- base/process/process_metrics_posix.cc
 +++ base/process/process_metrics_posix.cc
 @@ -21,7 +21,7 @@
@@ -690,7 +713,7 @@ index bdef95e4cc5..bc6d574db81 100644
  static const rlim_t kSystemDefaultMaxFds = 1024;
  #elif BUILDFLAG(IS_AIX)
 diff --git base/test/test_file_util_linux.cc base/test/test_file_util_linux.cc
-index f95a04ba3fa..3dc5b3855f3 100644
+index e1f6cf6c0eca..2dbde379d383 100644
 --- base/test/test_file_util_linux.cc
 +++ base/test/test_file_util_linux.cc
 @@ -52,7 +52,11 @@ bool EvictFileFromSystemCache(const FilePath& file) {
@@ -706,7 +729,7 @@ index f95a04ba3fa..3dc5b3855f3 100644
  #if !BUILDFLAG(IS_BSD)
    if (posix_fadvise(fd.get(), 0, 0, POSIX_FADV_DONTNEED) != 0)
 diff --git base/third_party/cityhash/city.cc base/third_party/cityhash/city.cc
-index db7afa1e511..2eb60ab24b8 100644
+index db7afa1e5116..2eb60ab24b82 100644
 --- base/third_party/cityhash/city.cc
 +++ base/third_party/cityhash/city.cc
 @@ -61,7 +61,7 @@ using std::pair;
@@ -719,11 +742,11 @@ index db7afa1e511..2eb60ab24b8 100644
  #include <sys/endian.h>
  #define bswap_32(x) bswap32(x)
 diff --git base/threading/platform_thread.h base/threading/platform_thread.h
-index f0740c11906..8c76e252919 100644
+index fcdb2b64e477..f9783b9cbbf8 100644
 --- base/threading/platform_thread.h
 +++ base/threading/platform_thread.h
-@@ -47,6 +47,8 @@ typedef zx_handle_t PlatformThreadId;
- typedef mach_port_t PlatformThreadId;
+@@ -53,6 +53,8 @@ typedef mach_port_t PlatformThreadId;
+ typedef uint64_t PlatformThreadId;
  #elif BUILDFLAG(IS_POSIX)
  typedef pid_t PlatformThreadId;
 +#elif defined(OS_DRAGONFLY)
@@ -732,13 +755,13 @@ index f0740c11906..8c76e252919 100644
  static_assert(std::is_integral_v<PlatformThreadId>, "Always an integer value.");
  
 diff --git base/threading/platform_thread_internal_posix.h base/threading/platform_thread_internal_posix.h
-index 1f724c19b4d..28760369639 100644
+index 09c01e31d85a..06819b82ba30 100644
 --- base/threading/platform_thread_internal_posix.h
 +++ base/threading/platform_thread_internal_posix.h
-@@ -9,6 +9,9 @@
+@@ -10,6 +10,9 @@
+ #include "base/base_export.h"
  #include "base/threading/platform_thread.h"
  #include "build/build_config.h"
- #include "third_party/abseil-cpp/absl/types/optional.h"
 +#if defined(OS_DRAGONFLY)
 +#include <sys/rtprio.h>
 +#endif
@@ -746,10 +769,10 @@ index 1f724c19b4d..28760369639 100644
  namespace base {
  
 diff --git base/threading/platform_thread_posix.cc base/threading/platform_thread_posix.cc
-index 97a8940101a..faeaacd1a00 100644
+index dab12e7fa88e..7aec576a9774 100644
 --- base/threading/platform_thread_posix.cc
 +++ base/threading/platform_thread_posix.cc
-@@ -14,6 +14,10 @@
+@@ -13,6 +13,10 @@
  #include <sys/types.h>
  #include <unistd.h>
  
@@ -761,7 +784,7 @@ index 97a8940101a..faeaacd1a00 100644
  #include <tuple>
  
 diff --git base/tracing/trace_time.cc base/tracing/trace_time.cc
-index 04df5e08bf5..37df5f7b675 100644
+index 04df5e08bf5f..37df5f7b6753 100644
 --- base/tracing/trace_time.cc
 +++ base/tracing/trace_time.cc
 @@ -8,7 +8,7 @@
@@ -774,10 +797,10 @@ index 04df5e08bf5..37df5f7b675 100644
  #endif
  
 diff --git build/build_config.h build/build_config.h
-index 24847036992..f8f63d75df5 100644
+index ac021d187375..d616f36c9033 100644
 --- build/build_config.h
 +++ build/build_config.h
-@@ -97,6 +97,8 @@
+@@ -110,6 +110,8 @@
  #define OS_NETBSD 1
  #elif defined(__OpenBSD__)
  #define OS_OPENBSD 1
@@ -786,7 +809,7 @@ index 24847036992..f8f63d75df5 100644
  #elif defined(__sun)
  #define OS_SOLARIS 1
  #elif defined(__QNXNTO__)
-@@ -119,7 +121,8 @@
+@@ -132,7 +134,8 @@
  
  // For access to standard BSD features, use OS_BSD instead of a
  // more specific macro.
@@ -796,7 +819,7 @@ index 24847036992..f8f63d75df5 100644
  #define OS_BSD 1
  #endif
  
-@@ -129,7 +132,7 @@
+@@ -142,7 +145,7 @@
      defined(OS_FREEBSD) || defined(OS_IOS) || defined(OS_LINUX) ||  \
      defined(OS_CHROMEOS) || defined(OS_MAC) || defined(OS_NACL) ||  \
      defined(OS_NETBSD) || defined(OS_OPENBSD) || defined(OS_QNX) || \
@@ -805,7 +828,7 @@ index 24847036992..f8f63d75df5 100644
  #define OS_POSIX 1
  #endif
  
-@@ -224,6 +227,12 @@
+@@ -249,6 +252,12 @@
  #define BUILDFLAG_INTERNAL_IS_OPENBSD() (0)
  #endif
  
@@ -819,19 +842,19 @@ index 24847036992..f8f63d75df5 100644
  #define BUILDFLAG_INTERNAL_IS_POSIX() (1)
  #else
 diff --git build/config/BUILDCONFIG.gn build/config/BUILDCONFIG.gn
-index d391e6ccc24..ebccdd1b4ac 100644
+index 87019b0f15ec..81a86d13ca21 100644
 --- build/config/BUILDCONFIG.gn
 +++ build/config/BUILDCONFIG.gn
-@@ -230,6 +230,8 @@ if (host_toolchain == "") {
+@@ -236,6 +236,8 @@ if (host_toolchain == "") {
      host_toolchain = "//build/toolchain/openbsd:clang_$host_cpu"
    } else if (host_os == "freebsd") {
      host_toolchain = "//build/toolchain/freebsd:clang_$host_cpu"
 +  } else if (host_os == "dragonfly") {
-+    host_toolchain = "//build/toolchain/linux:clang_$host_cpu"
++    host_toolchain = "//build/toolchain/dragonfly:clang_$host_cpu"
    } else {
      assert(false, "Unsupported host_os: $host_os")
    }
-@@ -273,7 +275,7 @@ if (target_os == "android") {
+@@ -279,7 +281,7 @@ if (target_os == "android") {
    _default_toolchain = "//build/toolchain/aix:$target_cpu"
  } else if (target_os == "zos") {
    _default_toolchain = "//build/toolchain/zos:$target_cpu"
@@ -840,7 +863,7 @@ index d391e6ccc24..ebccdd1b4ac 100644
    _default_toolchain = host_toolchain
  } else {
    assert(false, "Unsupported target_os: $target_os")
-@@ -310,10 +312,11 @@ is_chromeos = current_os == "chromeos"
+@@ -316,10 +318,11 @@ is_chromeos = current_os == "chromeos"
  is_fuchsia = current_os == "fuchsia"
  is_ios = current_os == "ios"
  is_linux = current_os == "linux" || current_os == "openbsd" ||
@@ -854,21 +877,8 @@ index d391e6ccc24..ebccdd1b4ac 100644
  is_mac = current_os == "mac"
  is_nacl = current_os == "nacl"
  is_win = current_os == "win" || current_os == "winuwp"
-diff --git build/config/compiler/BUILD.gn build/config/compiler/BUILD.gn
-index 7ef5b690e61..ce9cf5178e1 100644
---- build/config/compiler/BUILD.gn
-+++ build/config/compiler/BUILD.gn
-@@ -2073,7 +2073,7 @@ config("no_chromium_code") {
-       # third-party libraries.
-       "-Wno-c++11-narrowing",
-     ]
--    if (!is_nacl && !is_freebsd) {
-+    if (!is_nacl && !is_freebsd && !is_dragonfly) {
-       cflags += [
-         # Disabled for similar reasons as -Wunused-variable.
-         "-Wno-unused-but-set-variable",
 diff --git build/config/linux/pkg-config.py build/config/linux/pkg-config.py
-index 3caf00630d4..466f6c0849a 100755
+index 3caf00630d47..466f6c0849ae 100755
 --- build/config/linux/pkg-config.py
 +++ build/config/linux/pkg-config.py
 @@ -108,7 +108,7 @@ def main():
@@ -881,7 +891,7 @@ index 3caf00630d4..466f6c0849a 100755
      return 0
  
 diff --git build/config/ozone.gni build/config/ozone.gni
-index 83057adc0ff..db92fd33c1b 100644
+index 6a590b0ef24c..f02aad7366d9 100644
 --- build/config/ozone.gni
 +++ build/config/ozone.gni
 @@ -96,6 +96,10 @@ declare_args() {
@@ -896,7 +906,7 @@ index 83057adc0ff..db92fd33c1b 100644
        ozone_platform = "flatland"
        ozone_platform_flatland = true
 diff --git build/gn_run_binary.py build/gn_run_binary.py
-index 375ab503117..6c715cb9b6b 100644
+index 375ab503117f..6c715cb9b6b1 100644
 --- build/gn_run_binary.py
 +++ build/gn_run_binary.py
 @@ -23,7 +23,7 @@ if not os.path.isabs(path):
@@ -909,7 +919,7 @@ index 375ab503117..6c715cb9b6b 100644
    if ret <= -100:
      # Windows error codes such as 0xC0000005 and 0xC0000409 are much easier to
 diff --git build/landmine_utils.py build/landmine_utils.py
-index b126f4fff0f..9b4f517d2d2 100644
+index b126f4fff0fa..9b4f517d2d26 100644
 --- build/landmine_utils.py
 +++ build/landmine_utils.py
 @@ -11,7 +11,7 @@ def IsWindows():
